package main

import "fmt"
import "os"

/* Data x, restituisce un insieme con tutti gli anagrammi di x. 
   L'insieme è rappresentato da una mappa in cui gli elementi dell'insieme sono le chiavi
   e i valori sono tutti uguali a true.
 */
func anagrammi(x string) map[string]bool {
	var risultato map[string]bool
	risultato = make(map[string]bool)
	if len(x) == 1 {
		return map[string]bool{ x: true }
	} 
	for i := 0; i < len(x); i++ {
		carattereIniziale := string(x[i])
		resto := x[:i] + x[i+1:]
		anagrammiResto := anagrammi(resto)
		for x, _ := range anagrammiResto {
			anagramma := carattereIniziale + x
			risultato[anagramma] = true
		}
	}
	return risultato
}


func main() {
	x := os.Args[1]
	mappaAnagrammi := anagrammi(x)
	for k, _ := range mappaAnagrammi {
		fmt.Println(k)
	}
}