package main

import "fmt"
import "os"
import "slices"

/* Data x, restituisce una slice con tutti gli anagrammi di x. */
func anagrammi(x string) []string {
	var risultato []string
	if len(x) == 1 {
		return []string{ x }
	} 
	for i := 0; i < len(x); i++ {
		carattereIniziale := string(x[i])
		resto := x[:i] + x[i+1:]
		anagrammiResto := anagrammi(resto)
		for _, x := range anagrammiResto {
			anagramma := carattereIniziale + x
			// Prima di aggiungere l'anagramma controlliamo che non ci sia già
			if !slices.Contains(risultato, anagramma) {
				risultato = append(risultato, anagramma)
			}
		}
	}
	return risultato
}


func main() {
	x := os.Args[1]
	sliceAnagrammi := anagrammi(x)
	fmt.Println(sliceAnagrammi)
}